package com.muyu.marketing.controller;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.marketing.domain.model.ActivityTeamInfoListModel;
import com.muyu.marketing.domain.req.TeamInfoReqListReq;
import com.muyu.marketing.domain.req.ActivityTeamInfoSaveReq;
import com.muyu.marketing.domain.resp.TeamInfoListResp;
import com.muyu.marketing.service.ActivityTeamInfoService;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.concurrent.Phaser;

@Api(tags = "商品拼团信息")
@RestController
@RequestMapping("/team")
public class ActivityTeamController {
    @Autowired
    private ActivityTeamInfoService activityTeamInfoService;
    /**
     * 商品拼团列表
     * @param teamInfoReqListReq
     * @return
     */
    @PostMapping("list")
    public Result<PageInfo<TeamInfoListResp>> list(@RequestBody TeamInfoReqListReq teamInfoReqListReq){
        PageHelper.startPage(teamInfoReqListReq.getPageNum(),teamInfoReqListReq.getPageSize());
       TableDataInfo<ActivityTeamInfoListModel> tableDataInfo = activityTeamInfoService.query(teamInfoReqListReq.buildQueryModel());
        List<TeamInfoListResp> respList = tableDataInfo.getRows().stream().map(TeamInfoListResp::listModelBuild).toList();
        PageInfo<TeamInfoListResp> pageInfo = new PageInfo<>(respList);
        return Result.success(pageInfo);
//                new TableDataInfo<>(){{
//                    setRows(respList);
//                    setTotal(tableDataInfo.getTotal());
//                }}
    }

    /**
     * 商品拼团添加
     * @param teamInfoSaveReq
     * @return
     */
    @PostMapping("add")
    public Result add(@RequestBody ActivityTeamInfoSaveReq teamInfoSaveReq){
         Result addActivityTeamInfo = activityTeamInfoService.add(teamInfoSaveReq);
         return addActivityTeamInfo;
    }
}
